Program CreeLed; { Version 1.05 du 1-02-08 programmed by Mic** mic-josi@orange.fr}
Uses Crt,Graph,MaSouris,Strings;

  Type
  LED = Record         { Enregistrement des coordonnes et couleurs des LED }
  Cx : Array[1..8] of Integer;                 { Coordonnes X de la souris }
  Cy : Array[1..8] of Integer;                 { Coordonnes Y de la souris }
  Lx : Array[1..8] of Integer;  { Tableau binaire X d'une range de 16 LEDs }
  Ly : Array[1..8] of Integer;  { Tableau binaire Y d'une range de 16 LEDs }
  LedX: Array[1..64] of  Byte;      { Tableau binaire X des 256 LEDs rouges }
  LedY: Array[1..64] of  Byte;      { Tableau binaire Y des 256 LEDs vertes }
  Co :                    Byte;     { Variable couleur d'un pixel           }
  NomTab,CoulLED : string;          { Variable de reprage dans fichier     }
  End;

  Var
  x,y,lign,Xl,Yl     :Integer;       { variables utilises dans les boucles }
  ColX,ColY,tab      :Integer;
  et,V               :Integer;               { variables couleur et drapeau }
  Bouton,DrE,GrE,NbBp:Integer;                        { tat boutons souris }
  Dec                :Integer;          { variable  de transfert en dcimal }
  LD      : LED;                                     { variable du type LED }
  NouvTab : Boolean;                { pour les noms des tableaux 64 LEDs    }
  Slide : Text;                     { stockage des tableaux dans un fichier }
  Ap    : Boolean;               { drapeau premire ouverture fichier Slide }
  Texte : String ;               { pour la saisie dans les fichiers         }
  C,L   : Integer;               { idem                                     }

  Const
  {Centre X des LEDs}
  CoX: Array[1..8] of integer = (30,54,78,102,126,150,174,198);
  {Centre Y des LEDs}
  CoY: Array[1..8] of integer = (50,74,98,122,146,170,194,218);

{=========================================================================}
{ inclusion du pilote EGAVGA directement dans le programme excutable }
 procedure EGAVGAdriverProc; external;
           {$L PEGAVGA.OBJ}
{=========================================================================}
procedure Init_VGA;                                      { Init du mode VGA }
 Var
 GraphPilote, GraphMode,error,init :Integer;
 Begin
 Init := RegisterBGIdriver(@EGAVGAdriverProc);
         GraphPilote := VGA;
         GraphMode := VGAHI;               { Mode VGA 640 x 480 16 couleurs }
 InitGraph (GraphPilote,GraphMode,'');
 error := GraphResult;
 if(error <> 0) Then Begin
     Writeln ('Erreur Graphique ',GraphErrorMsg(error));
     readln;
 end;
End;
{=========================================================================}
    { Affichage fonte, direction, taille, position xy d'une chaine TXT }
 Procedure TxtDir(f,d,t,x,y :Integer;Txt:string);
 Begin
 SetTextStyle(f, d, t);
 outtextXY(x,y,Txt);
 End;

{==========================================================================}
Procedure DessinEcran;
Var
x,y :Integer;
Begin
SetColor(15);
Rectangle(1,1,637,263);
SetColor(8);
SetFillStyle(1,8);
Bar(1,266,638,479);
SetColor(15);
TxtDir(0,0,2,86,275,'LED SHOW MAKER BY M & J 2007');
SetTextStyle(0, 0, 1);
SetViewPort(0,0,638,264,ClipOff);
End;
{==========================================================================}
{ cette procedure s'utilise de la faon suivante: Saisie (colonne,ligne)
  cette procdure ne vrifie pas si la saisie dpasse l'cran, compter
  8 pixels de largeur et 14 pixels de hauteur par caractre inscrits
  Exemple: Saisie (100,50) saisie et affiche un texte  partir de la
  colonne 100 et de la ligne 50                                            }

Procedure Saisie(Cl,Ll:Integer);
Var
Ch : Char;
Car : Byte;
Begin
Texte :='';
C := Cl; {transfert de Cl dans C}
L := Ll;
Car := 0;
Repeat
MoveTo(C,L); { curseur en C,L }
Ch := ReadKey;                           { lit le caractre                }
If (Ch <> #13) and  (Ch <> #8) then
Texte := Texte + Ch ;                    { concatnation des caractres    }

While Ch = #8 do                         { tant que BackSpace Appuy faire }
Begin
Inc (Car);                      { incrment pour  le nombre de  Backspaces }
setcolor(0);                             { noir pour effacer               }
C:= C-8;  { colonne de 8 points en arrire (largeur d'un caractre complet }
Ch:=#219; { charge Ch par le caractre ASCII 219                           }
OutTextXY(C,L,Ch);  { l'inscrit en noir  l'cran                          }
Ch := ReadKey;      { et ainsi de suite                                    }
End;
If Car <> 0 then
Begin
Texte := Copy(Texte,1,Length(Texte)-Car); { retour arrire
         de X caractres pour les effacer dans la chaine }
if Ch <> #13 then Texte := Texte + Ch;
Car := 0;
End;
if (Ch <> #8) and (Ch <> #13) then
Begin
setcolor(15);             { caractre en blanc                             }
OutTextXY(C,L,Ch);        { et affichage                                   }
Inc (C,TextWidth ('H'));  { incrmente colonne de 8 points                 }
End;
Until Ch = #13;           { sort de la boucle avec ENTREE                  }
End;


{=========================================================================}
function Coul (cou:Integer):Integer;              { slection d'une couleur }
Begin
 SetColor(cou);
End;
{=========================================================================}
                                        { remplissage des couleurs des LEDs }
                         { (et) couleur (x y) coordonnes du pixel  tester }
procedure LedPaint(et:Byte; x,y:Integer);
Begin;
   Case et of
      2: If (V = 1) Then Begin                     { Si vert passer en gris }
                         Coul(8); SetFillStyle(1,8);
                         Floodfill(x,y,0);      End;
      4: Begin                                    { Si rouge passer en gris }
         Coul(8); SetFillStyle(1,8);
         Floodfill(x,y,0);
         End;
      8: If V = 0 Then Begin                      { Si gris passer en rouge }
                       Coul(4); SetFillStyle(1,4);
                       Floodfill(x,y,0);
                       End
                       Else If (V = 1) And (et = 8)
                       Then Begin              { ou si gris  passer en vert }
                            Coul(2);SetFillStyle(1,2);
                            Floodfill(x,y,0);
                            End;
  End;
End;
{=========================================================================}
procedure MaMouse;                               { utilisation de la souris }
Var
Mx,My :Integer;                  { position de la souris  l'initialisation }
Begin
Mx := 8;
My :=8;
Init_Mouse;                                   { Initialisation de la souris }
Set_Mouse(Mx,My);                                   { Position de la souris }
Show_Mouse;                                                { Souris visible }
end;
{=========================================================================}
   { copy d'une partie de texte dbutant  deb et finissant  long }
Function Mid(chaine:string;deb:byte;long:byte):string;
begin
   Mid:=copy(chaine,deb,long)
end;
{=========================================================================}
{ convertion d'un chiffre binaire de 8 bits en dcimal }
procedure Bin_Deci (Ch:string);
var ii,co,l:byte;
    c,i: longint;
    car,ch1: string;
begin
ch1:= '';
co:=1;
i:=1;
dec:=0 ;
co := length (ch);           { longueur de la chaine de 8 bits  convertir }
for ii := co downto 1 do
ch1 := ch1 + mid(ch,ii,1);
for ii := 1 to 8 do
begin
car := mid(ch1,ii,1);
if car = '1' then
begin
dec:= dec +i ;                    { addition progressive en dcimal de dec }
end;
i:=i +i;
end;
end;
{=========================================================================}
procedure SlideShow(Nombre:Integer;couleurAE:string);
 Begin
 if Ap = false then                               { test si nouveau fichier }
 Begin
 Assign(Slide,'Slide.txt');                 { cration du fichier slide.txt }
 Rewrite(Slide);                                 { et ouverture en criture }
 If NouvTab = true then
 WriteLn(Slide,LD.NomTAB);                 { enregistrement du nom de figure}
 Write(Slide,Nombre);                      { enregistrement du premier octet}
 Write(Slide,'    ');
 WriteLn(Slide,LD.CoulLED);                { enregistrement de la couleur   }
 Close(Slide);
 end
 Else
 Begin
 Assign(Slide,'Slide.txt');
 Append(Slide);                           { ouverture pour ajout des octets }
 If NouvTab = true then
 WriteLn(Slide,LD.NomTAB);                 { enregistrement du nom de figure}
 Write(Slide,Nombre);                     { enregistrement des octet suivant}
 Write(Slide,'    ');
 WriteLn(Slide,LD.CoulLED);                { enregistrement de la couleur   }
 Close(Slide);
 End;
 Ap := True;
 NouvTab := False;
 End;
{=========================================================================}
             { affiche les valeurs binaires et dcimales des lignes de LEDs }
procedure LEDsHexaDeci;
Var
                                      { chaines de transfert  rouge et vert }
BinByteR,BitR,BinByteV,BitV      : String;
                   { chaines de transfert (R8) (V8) des octets rouge ou vert}
DeciR8,DeciV8                    : String;
BinBitR,BinBitV                  : Byte;                { Bit rouge ou vert }
Colonne,Ligne                    : Integer;        { boucle dans le tableau }



Begin
               { mise  zro des variables pour viter les valeurs ronnes }
BinByteR := ''; BitR :=''; BinByteV := ''; BitV :='';
DeciR8:='';DeciV8:='';
ColX :=344;ColY:=42;
Ligne := 0;
SetColor(15);
OutTextXY(ColX + (TextWidth ('HHHHHHHHHHHHHHHHHHHHHHHHHHH')),
          ColY - (TextWidth ('H')), 'Dcimale');      { affiche les repairs }
OutTextXY(ColX + (TextWidth ('HHHHHHHH')),ColY - (TextWidth ('H')), 'Binaire');
For Colonne := 1 to 64 do          { lit les 64 Bits de chaque image  LEDs }
    begin
    Inc(Ligne);
    Inc(ColX,(TextWidth ('H'))); { incrment des X avec espacement 8 pixels }
    BinBitR := LD.LedX[Colonne];                { tat LED rouge sur un Bit }
    BinBitV := LD.LedY[Colonne];                { tat LED verte sur un Bit }
    Str(BinBitR,BitR);                  { conversion en chaine de caractre }
    BinByteR := BinByteR + BitR ;  { conversion  de 1 Bits en 8 Bits  rouge }
    Str(BinBitV,BitV);             { idem en vert                           }
    BinByteV := BinByteV + BitV ;

    if Ligne = 8 then                      { conversion en dcimal des 8
                                             premiers Bytes rouges et verts }
     Begin
     Bin_Deci(BinByteR);
     If Colonne < 129 Then
     Begin
     LD.CoulLED := 'Rouge';
     SlideShow (Dec,LD.CoulLED);
     End;
     Str(Dec,DeciR8);
     Bin_Deci(BinByteV);
     If Colonne < 129 Then
     Begin
     LD.CoulLED := 'Verte';
     SlideShow(Dec,LD.CoulLED);
     End;
     Str(Dec,DeciV8);
     BinByteV := BinByteV + '  ';
     BinByteR := BinByteR + '  ';
     end;
     if (Ligne = 8) then
     Begin
     ColX := 408;
    { conversion en dcimal des 8 Bytes rouges et verts }
     SetColor(4);
    { affichage des valeurs binaires et dcimales des ranges de LEDs rouges}
     OutTextXY(ColX,ColY,BinByteR);
     OutTextXY(ColX + (TextWidth ('HHHHHHHHHHHHHHHHHHH')),ColY , DeciR8);
     SetColor(2);
     OutTextXY(ColX,ColY + (TextWidth ('H')),BinByteV);
    { affichage des valeurs binaires et dcimales des ranges de LEDs vertes}
     OutTextXY(ColX + (TextWidth ('HHHHHHHHHHHHHHHHHHH')),ColY + 8 , DeciV8);
     ColY := ColY + (TextWidth ('HHH'));
     Ligne := 0;
     BinByteR :='';
     BinByteV :='';
     end;
     End;
     OutTextXY(10,ColY + (TextWidth ('H')),'appuyez sur f pour finir le tableau et l''enregister sous SLYDE.TXT');
     ReadKey;
End;

{=========================================================================}
{ dessine le tableau des 64 LEDs en gris }
procedure Matrice;
Begin
   While lign < 9 do
   Begin
    While x < 207 do
       Begin
       Coul (8);                                   { teint toutes les LEDs }
       Circle(x,y,9);                      { cercle de 9 pixels de diamtre }
       SetFillStyle(1,8);                     { trame de dessin sans motifs }
       Floodfill(x,y,8);              { remplissage du cercle avec la trame }
       x := x + 24;
       End;
   lign := lign + 1;
   y := y + 24;
   x := 30;
   End;
                         { affichage des repres des colonnes et des lignes }
 TxtDir(0,0,1,26,25,'8  7  6  5  4  3  2  1 ');
 TxtDir(0,1,1, 14,46,'1  2  3  4  5  6  7  8 ');
 SetTextStyle(0, 0, 1);
End;
{=========================================================================}
procedure Gris_Rouge;      { test la couleur des LEDs  avant de les allumer }
Begin
ColX := 0;ColY :=0 ;
For ColY := 1 to 8 do
    If LD.Ly[ColY] = 1 Then
       For ColX := 1 to 8 do
       Begin
       If LD.Lx[ColX] = 1 Then
          Begin
           et := GetPixel(LD.Cx[ColX],LD.Cy[ColY]);    { test couleur une LED }
           LD.Ly[ColY] := 0;
           LD.Lx[ColX] := 0;
           x:= LD.Cx[ColX];
           y:= LD.Cy[ColY];
           LedPaint(et,LD.Cx[ColX],LD.Cy[ColY]);   { appel procedure peinture }
          End;
       End;
 End;
{=========================================================================}
procedure MatLED;
             { encodage du tableau LD.Ly des LEDs rouges ou vertes en binaire
                                         suivant position LD.Cy de la souris }

Begin
 Case Yl Of
  41..59   : Begin LD.Cy[1] := 50; LD.Ly[1] := 1;  End;{coordonne Y une LED}
  65..83   : Begin LD.Cy[2] := 74; LD.Ly[2] := 1;  End;
  89..107  : Begin LD.Cy[3] := 98; LD.Ly[3] := 1;  End;
  113..131 : Begin LD.Cy[4] := 122; LD.Ly[4] := 1;  End;
  137..155 : Begin LD.Cy[5] := 146; LD.Ly[5] := 1;  End;
  161..179 : Begin LD.Cy[6] := 170; LD.Ly[6] := 1;  End;
  185..203 : Begin LD.Cy[7] := 194; LD.Ly[7] := 1;  End;
  209..227 : Begin LD.Cy[8] := 218; LD.Ly[8] := 1;  End;
   End;
End;
{=========================================================================}
procedure DessinLed;
Begin
 repeat
 Show_Mouse;                                       { curseur souris visible }
 Pos_Mouse(Bouton,Xl,Yl);
 LD.Co:= GetPixel(Xl,Yl);
                       { encodage du tableau LD.Lx des LEDs rouges en binaire
                                         suivant position LD.Cx de la souris }
  if (bouton = 1) then
  Begin

  Case Xl Of                                         { coordonne X une LED }
  21..39   : Begin  LD.Cx [1] := 30; MatLED; LD.Lx[1] := 1;   End;
  45..63   : Begin  LD.Cx [2] := 54; MatLED; LD.Lx[2] := 1;   End;
  67..87   : Begin  LD.Cx [3] := 78; MatLED; LD.Lx[3] := 1;   End;
  93..111  : Begin  LD.Cx [4] := 102; MatLED; LD.Lx[4] := 1;   End;
  117..135 : Begin  LD.Cx [5] := 126; MatLED; LD.Lx[5] := 1;   End;
  141..159 : Begin  LD.Cx [6] := 150;  MatLED; LD.Lx[6] := 1;   End;
  165..183 : Begin  LD.Cx [7] := 174;  MatLED; LD.Lx[7] := 1;   End;
  187..207 : Begin  LD.Cx [8] := 198;  MatLED; LD.Lx[8] := 1;   End;
    End;
End;
                     { encodage du tableau LD.Lx des LEDs vertes en binaire
                                         suivant position LD.Cx de la souris }

If bouton = 2 then
Begin
 V :=1;
 Case Xl Of
  21..39   : Begin  LD.Cx [1] := 30; MatLED; LD.Lx[1] := 1;   End;
  45..63   : Begin  LD.Cx [2] := 54; MatLED; LD.Lx[2] := 1;   End;
  67..87   : Begin  LD.Cx [3] := 78; MatLED; LD.Lx[3] := 1;   End;
  93..111  : Begin  LD.Cx [4] := 102; MatLED; LD.Lx[4] := 1;   End;
  117..135 : Begin  LD.Cx [5] := 126; MatLED; LD.Lx[5] := 1;   End;
  141..159 : Begin  LD.Cx [6] := 150;  MatLED; LD.Lx[6] := 1;   End;
  165..183 : Begin  LD.Cx [7] := 174;  MatLED; LD.Lx[7] := 1;   End;
  187..207 : Begin  LD.Cx [8] := 198;  MatLED; LD.Lx[8] := 1;   End;
    End;
End;
Delay(25);                               { dlai avant de cacher la souris }
Hide_Mouse;                                      { curseur souris invisible }
Until (bouton = 0);
Gris_Rouge;                         { appel procedure test couleur des LEDs }
V := 0;
End;
{=========================================================================}
procedure Tab_Color;              { encodage tableau des 256 LEDs en un seul
                                   tableau vert, rouge, ou gris             }
Begin
   tab := 0;
   x:=30;y:= 50;lign := 1;
   While lign < 9 do
   Begin
    While x < 206 do
       Begin
       et := GetPixel(x,y);
       inc(tab);
       Case et of
            2 : begin LD.LedX[tab] := 0;
                      LD.LedY[tab] := 1;
                end;
            4 : begin LD.LedX[tab] := 1;
                      LD.LedY[tab] := 0;
                end;
            8 : begin LD.LedX[tab] := 0;
                      LD.LedX[tab] := 0;
                end;
       end;
        x := x + 24;
       End;
   lign := lign + 1;
   y := y + 24;
   x := 30;
   End;
End;

{***************************************************************************}
                {   ****** PROGRAMME PRINCIPAL ****** }

Var
Fin,NouvLED : Char;
pass        : Boolean;
BEGIN
 Fin := ' ';NouvLED := ' ';
 ClrScr;
 GotoXY (5,10);
 Write('Crer un nouveau SlideLED (N) continuer un tableau SlideLED (C)  ');
 NouvLED := ReadKey;
 if  Upcase(NouvLED) = 'N' then
 Begin
 Ap := False;
 GotoXY(5,14);
 Write ('Nom du 1er tableau 64 LEDs ? ');
 ReadLn(LD.NomTab);
 NouvTab := True;
 End;
 If Upcase(NouvLED) = 'C' then Ap := true;
 if Ap = False then pass := false;
 Init_VGA;
 Repeat
 if pass = true then   { viter la question au premier passage }
 Begin
  Setcolor(15);
  ClearViewPort;
  OutTextXY(100,100,'Continuer la cration (O / N)');
  Fin := ReadKey;
 End;
 If UpCase(Fin) = 'N' Then
 Begin
 CloseGraph;
 Halt(0);
 End;

  If (UpCase(Fin) = 'O') or (Upcase(NouvLED) = 'C') Then
  Begin
  ClearViewPort;
  OutTextXY(100,100,'Nom du tableau 64 LEDs suivant ? ');
  Saisie(370,100);
  LD.NomTab := Texte;
  NouvTab := True;
  End;
  pass := true;
 ClearViewPort;
 MaMouse;
 x:=30;y:= 50;lign := 1;
 DessinEcran;
 Matrice;
  Repeat
  DessinLed;
  Until KeyPressed;
 Tab_Color;
 LEDsHexaDeci;
 ReadLn;
 Until UpCase (Fin) = 'F';
 CloseGraph;
END.                  { Fin du programme principal }
{********************* Fin du programme CREELED.PAS ***********************}
